package org.bossattack.speedblazer;

import org.newdawn.slick.Color;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.geom.Rectangle;

public class AICar extends Entity {
	
	public AICar(Game game, float x, float y) {
		super(game, x, y, Entity.AICar);
		
		this.width = game.civilianImage.getWidth();
		this.height = game.civilianImage.getHeight();
		
		bounds = new Rectangle(x, y, width, height);
	}
	
	public void update(int delta) {
		
		y += (game.speed-0.2f) * delta;
		
		if (y > SpeedBlazer.SCREENHEIGHT) {
			//y = 0 - height;
			game.removeEntity(this);
		}
		
		bounds.setX(x);
		bounds.setY(y);
	}
	
	public void draw(Graphics g) {
		//game.civilianImage.drawFlash(x+3, y+3, game.civilianImage.getWidth(), game.civilianImage.getHeight(), Color.black);
		game.civilianShadowImage.draw(x+5, y+5, game.civilianShadowImage.getWidth(), game.civilianShadowImage.getHeight(), Color.black);
		game.civilianImage.draw(x, y);
		
		if (game.debug) {
			g.setColor(Color.yellow);
			g.draw(bounds);
		}
	}
}
