package org.bossattack.speedblazer;

import java.util.ArrayList;

import org.lwjgl.opengl.GL11;
import org.newdawn.slick.Color;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.geom.Polygon;

public class AirJunk {

	ArrayList<Debris>debrisList = new ArrayList<Debris>();
	
	public void add(float x, float y) {
		int count = (int)(Math.random() * 5);
		
		for (int i = 0; i < count; i++) {
			debrisList.add(new Debris(x, y));
		}
	}
	
	public void update(int delta) {
		for (int i = 0; i < debrisList.size(); i++) {
			Debris d = debrisList.get(i);
			d.update(delta);
			
			if (d.time > 5000) {
				debrisList.remove(i);
				i--;
			}
		}
	}
	
	public void draw(Graphics g) {
		for (int i = 0; i < debrisList.size(); i++) {
			Debris d = debrisList.get(i);
			d.draw(g);
		}
	}
	
	private class Debris {
		
		Polygon p = new Polygon();
		
		float dx;
		float dy;
		
		float angle;
		float rotateSpeed;
		
		int time;
		
		public Debris(float x, float y) {
			int size = 20;
			int change = 10;
			
			// generate random polygon
			p.addPoint(0 + (int)(Math.random() * change), 0 + (int)(Math.random() * change));
			p.addPoint(size - (int)(Math.random() * change), 0 + (int)(Math.random() * change));
			p.addPoint(size - (int)(Math.random() * change), size - (int)(Math.random() * change));
			p.addPoint(0 + (int)(Math.random() * change), size - (int)(Math.random() * change));
		
			// center polygon
			p.setCenterX(x);
			p.setCenterY(y);
			
			// generate random direction
			dx = (0.03f + (float)Math.random() * 0.1f) * ((Math.random() > 0.5) ? 1 : -1);
			dy = (0.03f + (float)Math.random() * 0.1f) * ((Math.random() > 0.5) ? 1 : -1);
			
			rotateSpeed = 0.2f + (float)(Math.random() * 0.5f);
		}
		
		public void update(int delta) {
			p.setCenterX(p.getCenterX() + dx * delta);
			p.setCenterY(p.getCenterY() + dy * delta);
				
			angle += rotateSpeed * delta;
			
			time += delta;
		}
		
		public void draw(Graphics g) {
			GL11.glPushMatrix();
			
			GL11.glTranslatef(p.getCenterX(), p.getCenterY(), 0);
			GL11.glRotatef(angle, 1, 1, 1);
			GL11.glTranslatef(-p.getCenterX(), -p.getCenterY(), 0);
			
			//g.translate(p[i].getCenterX(), p[i].getCenterY());
			
			g.setColor(Color.red.darker());
			g.fill(p);
			g.setColor(Color.black);
			g.draw(p);
			
			GL11.glPopMatrix();
		}
	}
}
