package org.bossattack.speedblazer;

public class BigExplosion extends Entity {

	int explosionDelay = 100;
	int explosionTime = 100;
	
	int explosionStage = 0;
	
	int maxStages = 3;
	
	int distance = 25;
	
	public BigExplosion(Game game, float x, float y) {
		super(game, x, y, Entity.EXPLOSION);
		game.bigExplosionSnd.play();
	}
	
	public void update(int delta) {
		
		if (explosionTime < explosionDelay) {
			explosionTime += delta;
		}
		else {
			// reset time
			explosionTime = 0;
			// increment stage
			explosionStage++;
			
			if (explosionStage == 1) {
				game.addEntity(new Explosion(game, x, y));
				game.airJunk.add(x, y);
			}
			else if (explosionStage == 2) {
				
				for (int i = 0; i < 360; i+= 72) {
					addExplosion(distance, i);
				}
			}
			else if (explosionStage == 3) {
				for (int i = 0; i < 360; i+= 60) {
					addExplosion(distance*2, i);
				}
			}
			else if (explosionStage == 4) {
				for (int i = 0; i < 360; i+= 45) {
					addExplosion(distance*3, i);
				}
			}
			
			if (explosionStage >= maxStages) {
				game.removeEntity(this);
			}
		}
	}
	
	/**
	 * Method to help simplyify code a little
	 * 
	 */
	private void addExplosion(float distance, float angle) {
		float radian = (float)Math.toRadians(angle);
		
		game.addEntity(
				new Explosion(game, 
						x + (float)(distance * Math.sin(radian)), 
						y + (float)(distance * -Math.cos(radian))));
	}
}
