package org.bossattack.speedblazer;

import org.newdawn.slick.Animation;
import org.newdawn.slick.Color;
import org.newdawn.slick.Graphics;

public class Explosion extends Entity {
	
	Animation explosionImg;
	int explosionTime = 0, explosionDelay = 50 * 16;
	
	public Explosion(Game game, float x, float y) {
		super(game, x, y, Entity.EXPLOSION);
		explosionImg = new Animation(game.explosionSpriteSheet, 50);
	}
	
	public void update(int delta) {
		
		y += game.speed * delta;
		
		explosionTime += delta;
		
		if (explosionTime > explosionDelay) {
			game.removeEntity(this);
		}
	}
	
	public void draw(Graphics g) {
		explosionImg.draw(x - explosionImg.getWidth()/2, y - explosionImg.getHeight()/2);
	}
}
