package org.bossattack.speedblazer;

import org.newdawn.slick.Color;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.geom.Rectangle;

public class PoliceCar extends Entity {
	
	int lightTimer, lightDelay = 250;
	boolean flip = false;
	
	public PoliceCar(Game game, float x, float y) {
		super(game, x, y, Entity.AICar);
		
		this.width = game.civilianImage.getWidth();
		this.height = game.civilianImage.getHeight();
		
		bounds = new Rectangle(x, y, width, height);
	}
	
	public void update(int delta) {
		
		if (lightTimer < lightDelay) {
			lightTimer += delta;
		}
		else {
			lightTimer = 0;
			flip = !flip;
		}
		
		y += (game.speed-0.2f) * delta;
		
		if (y > SpeedBlazer.SCREENHEIGHT) {
			//y = 0 - height;
			game.removeEntity(this);
		}
		
		bounds.setX(x);
		bounds.setY(y);
	}
	
	public void draw(Graphics g) {
		game.carShadowImage.draw(x+3, y+3);
		game.policeImage.draw(x, y);
		if (!flip) {
			game.policeLightsImage.draw(x + 9, y + 30);
		}
		else {
			game.policeLightsImage.getFlippedCopy(true, false).draw(x + 9, y + 30);
		}
		
		if (game.debug) {
			g.setColor(Color.yellow);
			g.draw(bounds);
		}
	}
}
