package org.bossattack.speedblazer;

import java.util.ArrayList;

import org.newdawn.slick.Color;
import org.newdawn.slick.Graphics;

public class RoadLamps {

	Game game;
	
	float[] x = new float[4];
	float[] y = new float[4];
	
	boolean[] flip = new boolean[4];
	
	ArrayList fences = new ArrayList();
	int fenceWidth = 40;
	int fenceHeight = 60;
	float fenceY = 0;
	
	public RoadLamps(Game game) {
		this.game = game;
		
		// set up fence
		/*fences.add(new Fence(20, 0));
		fences.add(new Fence(250+30+60, 0));
		fences.add(new Fence(20, fenceHeight));
		fences.add(new Fence(250+30+60, fenceHeight));
		fences.add(new Fence(20, fenceHeight * 2));
		fences.add(new Fence(250+30+60, fenceHeight * 2));
		*/
		
		// set up lamp posts
		x[0] = 75 + 250;
		y[0] = 0 * 300;
		flip[0] = false;
		
		x[1] = 75 + 250;
		y[1] = 1 * 300;
		flip[1] = false;
		
		x[2] = 75;
		y[2] = 0 * 300 + 150;
		flip[2] = true;
		
		x[3] = 75;
		y[3] = 1 * 300 + 150;
		flip[3] = true;
	}
	
	public void update(int delta) {
		
		fenceY += game.speed * delta;
		if (fenceY > SpeedBlazer.SCREENHEIGHT) {
			fenceY = 0;
		}
		// scroll fence
		/*for (int i = 0; i < fences.size(); i++) {
			Fence fence = (Fence)fences.get(i);
			fence.y += game.speed * delta;
			if (fence.y > SpeedBlazer.SCREENHEIGHT) {
				fence.y = -fenceHeight;
			}
		}*/
		
		// scroll lamp posts
		for (int i = 0; i < 4; i++) {
			y[i] += game.speed * delta;
			if (y[i] > SpeedBlazer.SCREENHEIGHT) {
				y[i] = -10;
			}
		}
	}
	
	public void draw(Graphics g) {
		
		g.setColor(Color.gray);
		for (int i = 0; i < 20; i++) {
			float yPos = -600 + fenceY + i * fenceHeight;
			if (yPos > 600 || yPos < 0 - fenceHeight) {
				continue;
			}
			g.fillRect(20, -600 + fenceY + i * fenceHeight, fenceWidth, fenceHeight-5);
			g.fillRect(250+30+60, -600 + fenceY + i * fenceHeight, fenceWidth, fenceHeight-5);
		}
		
		g.setColor(new Color(127, 0, 127, 64));
		g.fillRect(0, 0, SpeedBlazer.SCREENWIDTH, SpeedBlazer.SCREENHEIGHT);
		
		g.setColor(new Color(1f, 1f, 0, 0.1f));
		for (int i = 0; i < 4; i++) {
			if (!flip[i]) {
				g.fillOval(x[i]-40, y[i]+(y[i]-300)/8f-10, 20, 20);
			}
			else {
				g.fillOval(x[i]+20, y[i]+(y[i]-300)/8f-10, 20, 20);
			}
		}
		
		g.setColor(Color.gray.darker());
		
		for (int i = 0; i < 4; i++) {
			if (!flip[i]) {
				g.fillRect(x[i] + 2, y[i], 10, (y[i]-300)/8f); // base
				g.fillRect(x[i] + 2+10, y[i]+(y[i]-300)/8f-5, -50, 10); // tip
			}
			else {
				g.fillRect(x[i] - 2-10, y[i], 10, (y[i]-300)/8f); // base
				g.fillRect(x[i] - 2-10, y[i]+(y[i]-300)/8f-5, 50, 10); // tip
			}
		}
	}
	
	class Lamp {
		float x;
		float y;
	}
	
	class Fence {
		float x;
		float y;
		
		public Fence(float x, float y) {
			this.x = x;
			this.y = y;
		}
	}
}
