package org.bossattack.speedblazer;

import org.newdawn.slick.Color;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.geom.Rectangle;

public class SlowRamp extends Entity {
	
	public SlowRamp(Game game, float x, float y) {
		super(game, x, y, Entity.SLOWRAMP);
		
		this.width = game.rampImage.getWidth();
		this.height = game.rampImage.getHeight();
		
		bounds = new Rectangle(x, y, width, height);
	}
	
	public void update(int delta) {
		
		y += game.speed * delta;
		
		if (y > SpeedBlazer.SCREENHEIGHT) {
			//y = 0 - height;
			//x = 75 + (int)(Math.random() * (250-game.rampImage.getWidth()));
			game.removeEntity(this);
		}
		
		bounds.setX(x);
		bounds.setY(y);
	}
	
	public void draw(Graphics g) {
		game.rampImage.getFlippedCopy(false, true).draw(x, y, Color.red);
		
		if (game.debug) {
			g.setColor(Color.yellow);
			g.draw(bounds);
		}
	}
}
