package org.bossattack.speedblazer;

import java.util.ArrayList;

import org.newdawn.slick.Color;
import org.newdawn.slick.Graphics;

public class Speed {

	int count = 5;
	
	ArrayList speedWaves = new ArrayList();
	
	float fade = 0f;
	
	public Speed() {
		for (int i = 0; i < count; i++) {
			SpeedWave s = new SpeedWave();
			generateSpeed(s);
			speedWaves.add(s);
		}
	}
	
	private void generateSpeed(SpeedWave s) {
		s.width = 5;
		s.height = 100 + (int)(Math.random() * 200);
		
		s.x = (int)(Math.random() * (SpeedBlazer.SCREENWIDTH-s.width));
		s.y = -s.height;
		
		s.dy = 0.6f + (float)(Math.random() * 0.5f);
	}
	
	public void update(int delta, float fade) {
		this.fade = fade;
		
		for (int i = 0; i < speedWaves.size(); i++) {
			SpeedWave s = (SpeedWave)speedWaves.get(i);
			s.y += s.dy * delta;
			if (s.y > SpeedBlazer.SCREENHEIGHT) {
				generateSpeed(s);
			}
		}
	}
	
	public void draw(Graphics g) {
		g.setColor(new Color(1.0f, 1.0f, 1.0f, 0.1f*fade));
		for (int i = 0; i < speedWaves.size(); i++) {
			SpeedWave s = (SpeedWave)speedWaves.get(i);
			g.fillOval(s.x, s.y, s.width, s.height);
		}
	}
	
	class SpeedWave {
		float x;
		float y;
		float width;
		float height;
		float dy;
	}
}
