package org.bossattack.speedblazer;

import org.lwjgl.opengl.GL11;
import org.lwjgl.util.glu.GLU;
import org.newdawn.slick.AppGameContainer;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.state.StateBasedGame;

/**
 * A test for basic image rendering
 *
 * @author 
 */
public class SpeedBlazer extends StateBasedGame {
	
	
	public static final int SCREENWIDTH = 400;
	public static final int SCREENHEIGHT = 600;
	
	public SpeedBlazer() {
		super("Speed Blazer");
	}
	

	public void initStatesList(GameContainer container) throws SlickException {
		enterOrtho(); // switch to 3d mode
		addState(new TitleState());
		addState(new Game());
	}
	
	public void keyPressed(int key, char c) {
		super.keyPressed(key, c);
	}
	
	/**
	 * Enter the 3d orthographic mode 
	 * 
	 * @param xsize The size of the panel being used
	 * @param ysize The size of the panel being used
	 */
	protected void enterOrtho() {
		float view = 5f;
		float camHeight = (float)(Math.tan(Math.toRadians(90 - view/2)) * SCREENHEIGHT/2);
		
		GL11.glMatrixMode(GL11.GL_PROJECTION);
		GL11.glLoadIdentity();
		
		GLU.gluPerspective(view, SCREENWIDTH/(float)SCREENHEIGHT, 1, 10000);
		GLU.gluLookAt(SCREENWIDTH/2, SCREENHEIGHT/2, -camHeight, SCREENWIDTH/2, SCREENHEIGHT/2, 0, 0, -1, 0);
		
		GL11.glMatrixMode(GL11.GL_MODELVIEW);
	}

	/**
	 * Entry point to our test
	 * 
	 * @param argv The arguments to pass into the test
	 */
	public static void main(String[] argv) throws Exception {
		AppGameContainer container = new AppGameContainer(new SpeedBlazer());
		container.setDisplayMode(SCREENWIDTH,SCREENHEIGHT,false);
		container.setVSync(true);
		container.setShowFPS(false);
		container.setAlwaysRender(true);
		container.start();
	}
}
