package org.bossattack.speedblazer;

import org.newdawn.slick.Color;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.geom.Rectangle;

public class Wall extends Entity {
	
	public Wall(Game game, float x, float y, float width, float height) {
		super(game, x, y, Entity.WALL);
		
		this.width = width;
		this.height = height;
		
		bounds = new Rectangle(x, y, width, height);
	}
	
	public void update(int delta) {
		
		y += game.speed * delta;
		
		if (y > SpeedBlazer.SCREENHEIGHT) {
			game.removeEntity(this);
			/*y = 0 - height;
			width = (int)(50 + Math.random() * 150);
			x = 75 + (int)(Math.random() * (250-width));
			bounds.setBounds(x, y, width, height);*/
		}
		
		bounds.setY(y);
	}
	
	public void draw(Graphics g) {
		g.setColor(Color.black);
		g.fillRect(x, y, width, height);
		
		float offsetX = ((x + width/2f) - 200)/28f;
		float offsetY = ((y + height/2f) - 300)/28f;
		
		Image w = game.wallImage.getScaledCopy(0.5f);
		g.fillRect(x + offsetX, y + offsetY, width, height, w, 0, 0);
		
		
		if (game.debug) {
			g.setColor(Color.yellow);
			g.draw(bounds);
		}
	}
}
